# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Readonly-XS
Version:	1.05
Release:	47.%{__distinit}%{__distvers}
Summary:	Companion module for Readonly
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Readonly-XS
Source0:	https://cpan.metacpan.org/modules/by-module/Readonly/Readonly-XS-%{version}.tar.gz
Patch0:		Readonly-XS-1.05-prereq.patch
Patch1:		Readonly-XS-1.05-interpreter.patch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Carp)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test suite
BuildRequires:	perl(Test::More)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Carp)
Requires:	perl(Readonly) >= 1.02

# Don't provide the private XS.so() lib
%{?perl_default_filter}

%description
Readonly::XS is a companion module for Readonly, to speed up read-only
scalar variables.

%prep
%setup -q -n Readonly-XS-%{version}

# Build process does not actually need perl(Readonly)
%patch -P 0

# Fix script interpreter for test suite since we're packaging it
%patch -P 1

# And tests don't need to be executable either
chmod -c -x t/test.t

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc README Changes t/
%{perl_vendorarch}/auto/Readonly/
%{perl_vendorarch}/Readonly/
%{_mandir}/man3/Readonly::XS.3*

%changelog
* Tue Jul 11 2023 Paul Howarth <paul@city-fan.org> - 1.05-47
- Perl 5.38 rebuild

* Tue May  9 2023 Paul Howarth <paul@city-fan.org> - 1.05-46
- Use SPDX-format license tag
- Avoid use of deprecated patch syntax

* Tue May 31 2022 Paul Howarth <paul@city-fan.org> - 1.05-43
- Perl 5.36 rebuild

* Fri May 21 2021 Paul Howarth <paul@city-fan.org> - 1.05-40
- Perl 5.34 rebuild

* Wed Jun 24 2020 Paul Howarth <paul@city-fan.org> - 1.05-37
- Perl 5.32 rebuild

* Thu May 30 2019 Paul Howarth <paul@city-fan.org> - 1.05-34
- Perl 5.30 rebuild

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 1.05-31
- Perl 5.28 rebuild

* Sun Aug  6 2017 Paul Howarth <paul@city-fan.org> - 1.05-28
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Aug 30 2016 Paul Howarth <paul@city-fan.org> - 1.05-24
- BR: perl-generators where available
- Simplify find commands using -empty and -delete
- Avoid doc-file dependency on /usr/bin/perl via the test suite

* Thu Jan 14 2016 Paul Howarth <paul@city-fan.org> - 1.05-22
- Spec clean-up:
  - Drop %%defattr, redundant since rpm 4.4
  - Prefer %%global over %%define
  - Drop obsoletes/provides for old -tests sub-package
  - Flesh out buildreqs
- Explicitly BR: perl-devel, needed for EXTERN.h

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 1.05-15
- Perl 5.18 rebuild

* Sun Aug 26 2012 Paul Howarth <paul@city-fan.org> - 1.05-13
- BR:/R: perl(Carp)

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> - 1.05-11
- Drop buildreqs for non-dual-lived modules perl(strict), perl(vars) and
  perl(warnings)
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> - 1.05-9
- Include test suite as %%doc
- No need to remove empty directories from buildroot
- Add buildreqs for Perl core modules that might be dual-lived
- Patch Makefile.PL to reflect that perl(Readonly) isn't needed for build
- Patch script interpreter for test suite
- Add filter for doc-file dependencies if we don't have %%perl_default_filter

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> - 1.05-8
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1.05-5
- Rebuild for perl 5.12.1 in Rawhide

* Wed Jun  2 2010 Paul Howarth <paul@city-fan.org> - 1.05-4
- Fix dist tag for RHEL-6 Beta

* Tue Nov 24 2009 Paul Howarth <paul@city-fan.org> - 1.05-3
- Import from Fedora
- Drop unnecessary makefile.pl.patch

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.05-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Feb 27 2009 Chris Weyl <cweyl@alumni.drew.edu> - 1.05-1
- Update to 1.05
- Filter our provides to prevent private lib from showing up
- Drop patch1; incorporated upstream as of 1.05

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.04-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.04-11
- Rebuild for perl 5.10 (again)

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.04-10.2
- Autorebuild for GCC 4.3

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.04-9.2
- Patch Carp::croak call for new perl

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.04-9
- Rebuild for new perl

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.04-8.2
- Add BR: perl(Test::More)

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.04-8.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Tue Aug 21 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.04-8
- Bump

* Fri Oct 06 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.04-7
- Bump for missing patch...

* Fri Oct 06 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.04-6
- Drop br on perl(Readonly), patch Makefile.PL as well
- Rework spec to use macros

* Thu Oct 05 2006 Christian Iseli <Christian.Iseli@licr.org> - 1.04-5
- Rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Tue Sep 19 2006 Chris Weyl <cweyl@alumni.drew.edu> - 1.04-4
- Bump for mass rebuild

* Thu Dec 08 2005 Michael A. Peters <mpeters@mac.com> - 1.04-3
- Proper version on perl(Readonly) BuildRequires & Requires

* Thu Dec 08 2005 Michael A. Peters <mpeters@mac.com> - 1.04-1
- New Version
- BuildRequires perl(Readonly), remove explicit requires on
  perl-Readonly version

* Thu Dec 08 2005 Michael A. Peters <mpeters@mac.com> - 1.03-2
- Fix license and BuildRequires

* Sat Nov 12 2005 Michael A. Peters <mpeters@mac.com> - 1.03-1
- Created spec file
